=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-02-15 22:58:59 +0000
+++ bzrlib/bzrdir.py	2010-02-15 23:45:03 +0000
@@ -380,20 +380,16 @@
             except errors.NoRepositoryPresent:
                 pass
             else:
-                return False, (None, repository)
-            try:
-                branch = bzrdir.open_branch()
-            except errors.NotBranchError:
-                return True, (None, None)
-            else:
-                return True, (branch, None)
-        branches = []
-        for branch, repo in BzrDir.find_bzrdirs(transport, evaluate=evaluate):
+                return False, ([], repository)
+            return True, (bzrdir.list_branches(), None)
+        ret = []
+        for branches, repo in BzrDir.find_bzrdirs(transport,
+                                                  evaluate=evaluate):
             if repo is not None:
-                branches.extend(repo.find_branches())
-            if branch is not None:
-                branches.append(branch)
-        return branches
+                ret.extend(repo.find_branches())
+            if branches is not None:
+                ret.extend(branches)
+        return ret
 
     def destroy_repository(self):
         """Destroy the repository in this BzrDir"""

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2010-02-01 11:40:56 +0000
+++ bzrlib/repository.py	2010-02-15 23:45:03 +0000
@@ -1484,10 +1484,7 @@
         :param using: If True, list only branches using this repository.
         """
         if using and not self.is_shared():
-            try:
-                return [self.bzrdir.open_branch()]
-            except errors.NotBranchError:
-                return []
+            return self.bzrdir.list_branches()
         class Evaluator(object):
 
             def __init__(self):
@@ -1502,22 +1499,19 @@
                     except errors.NoRepositoryPresent:
                         pass
                     else:
-                        return False, (None, repository)
+                        return False, ([], repository)
                 self.first_call = False
-                try:
-                    value = (bzrdir.open_branch(), None)
-                except errors.NotBranchError:
-                    value = (None, None)
+                value = (bzrdir.list_branches(), None)
                 return True, value
 
-        branches = []
-        for branch, repository in bzrdir.BzrDir.find_bzrdirs(
+        ret = []
+        for branches, repository in bzrdir.BzrDir.find_bzrdirs(
                 self.bzrdir.root_transport, evaluate=Evaluator()):
-            if branch is not None:
-                branches.append(branch)
+            if branches is not None:
+                ret.extend(branches)
             if not using and repository is not None:
-                branches.extend(repository.find_branches())
-        return branches
+                ret.extend(repository.find_branches())
+        return ret
 
     @needs_read_lock
     def search_missing_revision_ids(self, other, revision_id=None, find_ghosts=True):

